diff --git a/tools/testing/selftests/bpf/Makefile b/tools/testing/selftests/bpf/Makefile
index a231cca9882f..9d507615383b 100644
--- a/tools/testing/selftests/bpf/Makefile
+++ b/tools/testing/selftests/bpf/Makefile
@@ -350,7 +350,8 @@ LINKED_SKELS := test_static_linked.skel.h linked_funcs.skel.h		\
 		test_subskeleton.skel.h test_subskeleton_lib.skel.h	\
 		test_usdt.skel.h tracing_multi_fentry_test.skel.h	\
 		tracing_multi_fexit_test.skel.h				\
-		tracing_multi_fentry_fexit_test.skel.h
+		tracing_multi_fentry_fexit_test.skel.h			\
+		tracing_multi_mixed_test.skel.h
 
 LSKELS := kfunc_call_test.c fentry_test.c fexit_test.c fexit_sleep.c \
 	test_ringbuf.c atomics.c trace_printk.c trace_vprintk.c \
@@ -371,6 +372,7 @@ test_usdt.skel.h-deps := test_usdt.o test_usdt_multispec.o
 tracing_multi_fentry_test.skel.h-deps := tracing_multi_fentry.o tracing_multi_check.o
 tracing_multi_fexit_test.skel.h-deps := tracing_multi_fexit.o tracing_multi_check.o
 tracing_multi_fentry_fexit_test.skel.h-deps := tracing_multi_fentry_fexit.o tracing_multi_check.o
+tracing_multi_mixed_test.skel.h-deps := tracing_multi_mixed.o tracing_multi_check.o
 
 LINKED_BPF_SRCS := $(patsubst %.o,%.c,$(foreach skel,$(LINKED_SKELS),$($(skel)-deps)))
 
diff --git a/tools/testing/selftests/bpf/prog_tests/tracing_multi.c b/tools/testing/selftests/bpf/prog_tests/tracing_multi.c
index 409bcf1e3653..416940dcde48 100644
--- a/tools/testing/selftests/bpf/prog_tests/tracing_multi.c
+++ b/tools/testing/selftests/bpf/prog_tests/tracing_multi.c
@@ -3,6 +3,7 @@
 #include "tracing_multi_fentry_test.skel.h"
 #include "tracing_multi_fexit_test.skel.h"
 #include "tracing_multi_fentry_fexit_test.skel.h"
+#include "tracing_multi_mixed_test.skel.h"
 #include "trace_helpers.h"
 
 static void multi_fentry_test(void)
@@ -80,6 +81,70 @@ static void multi_fentry_fexit_test(void)
 	tracing_multi_fentry_fexit_test__destroy(skel);
 }
 
+static void multi_mixed_test(void)
+{
+	struct bpf_link *linkm1 = NULL, *linkm2 = NULL;
+	struct bpf_link *link1 = NULL, *link2 = NULL;
+	LIBBPF_OPTS(bpf_test_run_opts, topts);
+	struct tracing_multi_mixed_test *skel = NULL;
+	int err, prog_fd;
+
+	skel = tracing_multi_mixed_test__open_and_load();
+	if (!ASSERT_OK_PTR(skel, "tracing_multi_mixed_test__open_and_load"))
+		goto cleanup;
+
+	link1 = bpf_program__attach_trace(skel->progs.test1);
+	if (!ASSERT_OK_PTR(link1, "attach_trace"))
+		goto cleanup;
+
+	link2 = bpf_program__attach_trace(skel->progs.test2);
+	if (!ASSERT_OK_PTR(link2, "attach_trace"))
+		goto cleanup;
+
+	linkm1 = bpf_program__attach_tracing_multi(skel->progs.test3,
+						  "bpf_fentry_test*", NULL);
+	if (!ASSERT_OK_PTR(linkm1, "attach_tracing_multi"))
+		goto cleanup;
+
+	linkm2 = bpf_program__attach_tracing_multi(skel->progs.test4,
+						  "bpf_fentry_test*", NULL);
+	if (!ASSERT_OK_PTR(linkm2, "attach_tracing_multi"))
+		goto cleanup;
+
+	prog_fd = bpf_program__fd(skel->progs.test1);
+	err = bpf_prog_test_run_opts(prog_fd, &topts);
+	ASSERT_OK(err, "test_run");
+
+	ASSERT_EQ(skel->bss->test1_result, 1, "test1_result");
+	ASSERT_EQ(skel->bss->test2_result, 1, "test2_result");
+	ASSERT_EQ(skel->bss->test3_arg_result, 8, "test3_arg_result");
+	ASSERT_EQ(skel->bss->test4_arg_result, 8, "test4_arg_result");
+	ASSERT_EQ(skel->bss->test4_ret_result, 8, "test4_ret_result");
+
+	bpf_link__destroy(link1);
+	bpf_link__destroy(link2);
+	bpf_link__destroy(linkm1);
+	bpf_link__destroy(linkm2);
+
+	linkm2 = link1 = link2 = NULL;
+
+	linkm1 = bpf_program__attach_tracing_multi(skel->progs.test3,
+						  "bpf_fentry_test*", NULL);
+	if (!ASSERT_OK_PTR(linkm1, "attach_tracing_multi"))
+		goto cleanup;
+
+	link1 = bpf_program__attach_trace(skel->progs.test1);
+	if (!ASSERT_ERR_PTR(link1, "attach_trace"))
+		goto cleanup;
+
+cleanup:
+	bpf_link__destroy(link1);
+	bpf_link__destroy(link2);
+	bpf_link__destroy(linkm1);
+	bpf_link__destroy(linkm2);
+	tracing_multi_mixed_test__destroy(skel);
+}
+
 void test_tracing_multi_test(void)
 {
 	if (test__start_subtest("fentry"))
@@ -88,4 +153,6 @@ void test_tracing_multi_test(void)
 		multi_fexit_test();
 	if (test__start_subtest("fentry_fexit"))
 		multi_fentry_fexit_test();
+	if (test__start_subtest("mixed"))
+		multi_mixed_test();
 }
diff --git a/tools/testing/selftests/bpf/progs/tracing_multi_mixed.c b/tools/testing/selftests/bpf/progs/tracing_multi_mixed.c
new file mode 100644
index 000000000000..468a044753e9
--- /dev/null
+++ b/tools/testing/selftests/bpf/progs/tracing_multi_mixed.c
@@ -0,0 +1,43 @@
+// SPDX-License-Identifier: GPL-2.0
+#include <linux/bpf.h>
+#include <bpf/bpf_helpers.h>
+#include <bpf/bpf_tracing.h>
+
+char _license[] SEC("license") = "GPL";
+
+__hidden extern void multi_arg_check(__u64 *ctx, __u64 *test_result);
+__hidden extern void multi_ret_check(void *ctx, __u64 *test_result);
+
+__u64 test1_result = 0;
+SEC("fentry/bpf_fentry_test1")
+int BPF_PROG(test1, int a)
+{
+	test1_result += a == 1;
+	return 0;
+}
+
+__u64 test2_result = 0;
+SEC("fexit/bpf_fentry_test2")
+int BPF_PROG(test2, int a, __u64 b, int ret)
+{
+	test2_result += a == 2 && b == 3;
+	return 0;
+}
+
+__u64 test3_arg_result = 0;
+SEC("fentry.multi/bpf_fentry_test*")
+int BPF_PROG(test3, __u64 a, __u64 b, __u64 c, __u64 d, __u64 e, __u64 f)
+{
+	multi_arg_check(ctx, &test3_arg_result);
+	return 0;
+}
+
+__u64 test4_arg_result = 0;
+__u64 test4_ret_result = 0;
+SEC("fexit.multi/bpf_fentry_test*")
+int BPF_PROG(test4, __u64 a, __u64 b, __u64 c, __u64 d, __u64 e, __u64 f, int ret)
+{
+	multi_arg_check(ctx, &test4_arg_result);
+	multi_ret_check(ctx, &test4_ret_result);
+	return 0;
+}